#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

struct node {
    ll ans, pref, suf, type_pref, type_suf, first_pref, last_suf, flag;
};

const int MAXN = 3e5;
node tree[MAXN * 4];
array<ll, MAXN> a;

node merge(node ln, node rn) {
    if (ln.last_suf > rn.first_pref) {
        ll npref, ntype_p, nflag;
        if (ln.flag) {
            npref += 1;
            if ((ln.suf == 1 && rn.suf == 1) || (ln.type_suf == 1 && rn.type_pref == 1)) {
                ntype_p = 1;
                if (rn.flag) {
                    nflag = 1;
                }
            } else {
                ntype_p = 2;
                nflag = 0;
            }
        } else {
            npref = ln.pref;
            ntype_p = ln.type_pref;
            nflag = 0;
        }
        node n = {ln.ans * 2 + rn.ans, npref, rn.pref, ntype_p, rn.type_suf,
                  ln.first_pref, rn.last_suf, nflag};;
        return n;
    } else if (ln.type_suf > 0 && ln.last_suf < rn.first_pref) {
        ll nsuf, ntype_s;
        if (rn.flag) {
            nsuf += 1;
            ntype_s = 2;
        } else {
            nsuf = rn.suf;
            ntype_s = rn.type_suf;
        }
        node n = {ln.ans + rn.ans * 2, ln.pref, nsuf, ln.type_pref, ntype_s,
                  ln.first_pref, rn.last_suf, 0};
        return n;
    } else if (ln.last_suf == rn.first_pref) {
        node n = {ln.ans + rn.ans, ln.pref, rn.suf, ln.type_pref, rn.type_suf,
                  ln.first_pref, rn.last_suf, 0};
        return n;
    } else if (ln.type_suf == rn.type_pref || (ln.type_suf == 0 && rn.type_pref != 1)) {
        ll npref, nsuf, nflag;
        if (ln.flag) {
            npref = ln.suf + rn.pref;
        } else {
            npref = ln.pref;
        }
        if (rn.flag) {
            nsuf = ln.suf + rn.pref;
        } else {
            nsuf = rn.suf;
        }
        if (ln.flag && rn.flag) {
            nflag = 1;
        } else {
            nflag = 0;
        }
        node n = {ln.ans + rn.ans + ln.suf * rn.pref, npref, nsuf,
                  ln.type_pref, rn.type_suf, ln.first_pref, rn.last_suf, nflag};
        return n;
    }

}

node build(ll v, ll l, ll r) {
    if (r - l == 1) {
        node n = {1, 1, 1, 0, 0, a[l], a[l], 1};
        tree[v] = n;
        return tree[v];
    }
    ll mid = (l + r) / 2;
    tree[v] = merge(build(v * 2 + 1, l, mid), build(v * 2 + 2, mid, r));
    return tree[v];
}

int main() {
    ll n, k;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> k;
        a[i] = k;
    }
    build(0, 0, n);
    cout << tree[0].ans;
    return 0;
}